unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Edit1: TEdit;
    Label1: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    BitBtn1: TBitBtn;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Label11: TLabel;
    Label12: TLabel;
    ListBox9: TListBox;
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    LoadFile1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    About2: TMenuItem;
    Label13: TLabel;
    Exit2: TMenuItem;
    Shape3: TShape;
    Memo1: TMemo;
    procedure LoadFile1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2, Unit3;

{$R *.DFM}
var CSAddr, Cs1, Cs2, Cs3, kal_l, kal_w : integer;
var CSLTH, PAddr : integer;

procedure TForm1.LoadFile1Click(Sender: TObject);
begin
CSAddr := 0; Cs1:=0;  Cs2:=0;  Cs2:=0;  kal_w:=0; kal_l := 0;
CSLTH := 0; PAddr := 0;
Edit1.Clear;Edit1.SetFocus; ListBox1.Clear;ListBox2.Clear;ListBox3.Clear;
ListBox4.Clear; ListBox9.Clear; Memo1.Clear;
OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
OpenDialog1.Filter := 'Text files (*.txt)|*.txt|All files (*.*)|*.*';
OpenDialog1.FilterIndex := 1; { start the dialog showing all files }
if OpenDialog1.Execute then
  with OpenDialog1.Files do
    begin
      Form2.ListBox1.Items.LoadFromFile(strings[0]);    { Read the first line out of the file }
      Form2.ListBox2.Items.LoadFromFile(strings[1]);    { Read the first line out of the file }
      Form2.ListBox3.Items.LoadFromFile(strings[2]);    { Read the first line out of the file }
    end;
 MessageDlg('Enter "Program Load Addres" simulating OS in the Edit Box',
            mtInformation,[mbOK],0);
end;

procedure TForm1.N1Click(Sender: TObject);
begin
OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
OpenDialog1.Filter := 'Text files (*.txt)|*.txt|All files (*.*)|*.*';
OpenDialog1.FilterIndex := 1; { start the dialog showing all files }
if OpenDialog1.Execute then
  with OpenDialog1.Files do
    begin
      Form3.Memo3.Lines.LoadFromFile(strings[0]);    { Read the first line out of the file }
      Form3.Memo2.Lines.LoadFromFile(strings[1]);    { Read the first line out of the file }
      Form3.Memo1.Lines.LoadFromFile(strings[2]);    { Read the first line out of the file }
      form3.Visible := True;
    end;
end;

procedure Search(str : string; Obj : TListBox);
var
 index : integer;
begin
 for index := 0 to Obj.Items.Count -1 do
     if str = Obj.Items[index] then
       if MessageDlg(' Duplicate external symbol '+ str+ ', exiting',
                 mtError,[mbOK],0) = mrOK then Form1.close;
end;
procedure Parse(Obj : TListBox);
var
CSAddr,leng, index, len : integer;
Pname, dummy : string;
begin
  CSAddr := PAddr;
  Form1.ListBox3.Items.Add(IntToStr(CSAddr)); {starting Addres}
  dummy := Obj.Items[0]; {Header record}
  Pname := copy(dummy,2,6);   {DIKKAT SAGDAKININ BIR EKSIGINI YAZ}
  Search(Pname,Form1.ListBox1);
  Form1.ListBox1.Items.Add(Pname); {Program Name}
  Pname := copy(dummy,16,4); {Program length, ikinci alet kac kopylayacan o}
  CSLTH:= StrToInt(Pname);
  Form1.ListBox4.Items.Add(Pname);
{Now Get Defs and Refs}
  dummy := Obj.Items[1]; {Header record}
  if dummy[1] = 'D' then
   begin
     Form1.ListBox1.Items.Add(' ');
     Form1.ListBox4.Items.Add(' ');
     Pname := copy(dummy,2,6);
     Search(Pname,Form1.ListBox2);
     Form1.ListBox2.Items.Add(' '); {dummy bosluk}
     Form1.ListBox2.Items.Add(Pname); {Program Name}
     Pname := copy(dummy,8,6);
     leng := CsAddr + StrToInt(Pname); {realtive addr. of the symbol}
     Form1.ListBox3.Items.Add(IntToStr(leng)); {Absolute Address}
     index := 14;
     len := length(dummy);
   while index < len do
    begin
     Form1.ListBox1.Items.Add(' ');
     Form1.ListBox4.Items.Add(' ');
     Pname := copy(dummy,index,6);
     Search(Pname,Form1.ListBox2);
     Form1.ListBox2.Items.Add(Pname); {Program Name}
     Pname := copy(dummy,index+6,6);
     leng := CsAddr + StrToInt(Pname); {realtive addr. of the symbol}
     Form1.ListBox3.Items.Add(IntToStr(leng)); {Absolute Address}
     index := index + 11;
    end;
   end;
end;


procedure Load(Obj : TListBox);
var
 Pvar, dummy : string;
 index, len, line, kaldigi_l, kaldigi_w, i,j : integer;
begin
 kaldigi_l := kal_l; kaldigi_w := kal_w;
 index := 3;   {Trecords}
 with Form1 do
  begin
     dummy := Obj.Items[index];
     Pvar := copy(dummy,2,6);   {starting address}
     //start := Csr + StrToInt(Pvar);
     line := StrToInt(Pvar) div 16; {kac satir .. koyacaz}
     len :=  StrToInt(Pvar) mod 16 ;{Bir satirda kacinci positiondan baslayacak}
   i:=1; j :=kaldigi_w + 1;
   while i <= 16*line + len  do
    begin
       if ((j mod 5) = 0) and (j <> 0) then
        begin
           j := j +1;
           Memo1.Lines[kaldigi_l] := Memo1.Lines[kaldigi_l] + ' ';
           kaldigi_w := kaldigi_w + 1;
        end
       else
        begin
         Memo1.Lines[kaldigi_l] := Memo1.Lines[kaldigi_l] + '??';
         kaldigi_w := kaldigi_w + 1;j := j + 1;
         if  {((((i mod 16) = 0) and (i<>0))}  (j = 20) then
          begin
          j := 1; kaldigi_w := 0;
           kaldigi_l := kaldigi_l + 1;Memo1.Lines.Add('');
          end;
         i := i + 1;
        end;
    end;

{simdi ..... olayini yaptik, simdi T'leri yerlestirelim}
   //j := 1;
   j := kaldigi_w+1;
   while (dummy[1] <> 'M') do
    begin
     Pvar := copy(dummy,8,2); {T_Record'un uzunlugu}
     len := StrToInt(Pvar);
     i := 1;
     while i <= len do
      begin
       if (j mod 5) = 0 then
        begin
           j := j +1;
           Memo1.Lines[kaldigi_l] := Memo1.Lines[kaldigi_l] + ' ';
        end
       else
        begin
           Pvar := copy(dummy,8 + (2*i),2);
           Memo1.Lines[kaldigi_l] := Memo1.Lines[kaldigi_l] + Pvar;
           i := i + 1;
           j := j + 1;
        end;

       if  kaldigi_w = 16 then
        begin
         kaldigi_w := 0;
         kaldigi_l := kaldigi_l + 1;
        end
       else
         kaldigi_w := kaldigi_w + 1;
      end;{end 'while'}
     index := index + 1;
     dummy := Obj.Items[index];
    end; {end 'while'}
  kal_l := kaldigi_l; kal_w := kaldigi_w;
 end; {end 'with'}

end;{end 'load'}
procedure TForm1.BitBtn1Click(Sender: TObject);
var
 dummy : string;
 addr, added,i : integer;
begin
 CSLTH := 0;
 PAddr := StrToint(Edit1.Text);
 Cs1 := PAddr;
  Parse(Form2.ListBox3);
 PAddr := PAddr + CSLTH;
 Cs2 := PAddr;
  Form1.Listbox1.Items.Add('----------------------');
  Form1.Listbox2.Items.Add('-----------------------');
  Form1.Listbox3.Items.Add('------------------');
  Form1.Listbox4.Items.Add('-------------------');
  Parse(Form2.ListBox2);
 PAddr := PAddr + CSLTH;
 Cs3 := PAddr;
  Form1.Listbox1.Items.Add('-----------------------');
  Form1.Listbox2.Items.Add('----------------------');
  Form1.Listbox3.Items.Add('-------------------');
  Form1.Listbox4.Items.Add('----------------------');
  Parse(Form2.ListBox1);
     {if a explicit address is given in the 'E' record}
  dummy := Form2.ListBox1.Items[Form2.ListBox1.Items.Count-1];
  added := 0;

  ListBox9.Items.Add(IntToStr(StrToInt(ListBox3.Items[0]) + added));
  CsAddr := Cs1 + added;
  addr := CsAddr;
  for i:= 0 to 24 do
   begin
    ListBox9.Items.Add(IntToStr(addr+16));
    addr:=addr + 16;
   end;
  kal_l := 0; kal_w := 0;
  Load(Form2.ListBox3);
  CsAddr := Cs2 + added;
  Load(Form2.ListBox2);
  CsAddr := Cs3 + added;
 Load(Form2.ListBox1);

end;
procedure TForm1.About2Click(Sender: TObject);
begin
  MessageDlg('By Gurkan Ozturk, 1097682',mtinformation,
                 [mbOK],0);

end;

procedure TForm1.Help2Click(Sender: TObject);
begin
     MessageDlg('Please refer to word document named "Ceng332_Pro2.doc" which comes with the package',mtInformation,
                 [mbOk],0);
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
        close;
end;

end.
