//Name : Buket ULU
//  ID : 105330-5
// Hw3 : Linker/Loader

#include<stdio.h>
#include<iostream.h>
#include<string.h>
#include<stdlib.h>

#define HEADER	1
#define TEXT    2
#define DEFINE  3
#define REFER   4
#define MODIF   5
#define END     6
 
int length(char * s){
	int i=0;
	while (s[i]!='\0') i++;
	return i;
}
class Input_class{
  public:
	FILE * in_file;
	FILE * out_file;
	int record_type;
	int t_index;
	int pass1;
	struct estr{
		int address;
	}end;
	struct hstr{
		char name[7];
		int start;
		int length;
		int prog_addr;
	}header;
	struct dstr{
		int num;
		char name[7];
		int address;
	}define[6];
	struct rstr{
		int address;
		//int ref;
		char name[7];
	}refer[12];
	struct tstr{
		int start;
		int length;
		char obj[71];
	}text[2];
	struct mstr{
		int start;
		int length;
		char sign;
		char ref[8];
	}modif;
	int end_of_file;
	FILE * tmp;
  public:
	Input_class();
	void read_file();
	void close_open();	
	void write_tmp();
	void close_tmp();
	void write_file();
};

void Input_class::close_tmp(){
	fclose(tmp);
	return;
}
void Input_class::write_tmp(){
	fprintf(tmp,"%4x %70s\n",text[0].start,text[0].obj);
	fprintf(tmp,"%4x %70s\n",text[1].start,text[1].obj);
	return;
}
void Input_class::write_file(){
	int bas=16*16*16*4;
	int ml,i;
	char obj[71];
	tmp=fopen("tmp","r");
	fprintf(out_file,"Memory Address   Contents\n");
	fprintf(out_file,"%s   %s\n","--------------","---------------");
	fprintf(out_file,"%14x  ",bas);
	while (fscanf(tmp,"%4x   %s\n",&ml,obj)!=EOF){
		while (bas!=ml){
			fprintf(out_file,"%s\n","          xxxx"); bas=ml;
		}
		for(int k=0;obj[k]!='\0';k++){
			fprintf(out_file,"%14x              ",bas);
			fputc(obj[k],out_file); k++;
			fputc(obj[k],out_file); 
			fputc('\n',out_file);
			bas++;
		}	
	}
	fclose(tmp);
	fclose(out_file);
	return;

}
void Input_class::close_open(){
	pass1=0;
	fclose(in_file);	
	in_file=fopen("object","r");
	end_of_file=0;
	header.name[0]='\0';
	define[0].name[0]='\0';
	refer[0].name[0]='\0';
}
void Input_class::read_file(){
	char c;
        int i=0,file;
	file=fgetc(in_file);
	if (file==EOF) { 
		end_of_file=1;
		return;
	}
	c=char(file);
	switch (c){
	   case 'H':{
		record_type=HEADER;
		fscanf(in_file,"%6s%6x%6x\n",header.name,&header.start,&header.length);
		t_index=0;
		}break;
	   case 'D':{
		record_type=DEFINE;
		int i=0;
		for(char c=(char)fgetc(in_file);c!='\n';c=(char)fgetc(in_file)){
			ungetc((int)c,in_file);
			fscanf(in_file,"%6s%6x",define[i].name,&define[i].address);
			i++;
		}
		define[i].name[0]='\0';
		define[0].num=i;
		}break;
	   case 'R':{
		record_type=REFER;
		int i=0;
		for(char c=(char)fgetc(in_file);c!='\n';c=(char)fgetc(in_file)){
			ungetc((int)c,in_file);
			fscanf(in_file," %6s",&refer[i].name);
			i++;
		}
		refer[i].name[0]='\0';
		}break;
	   case 'T':{
		record_type=TEXT;
		fscanf(in_file,"%6x%2x%s\n",&text[t_index].start,&text[t_index].length,text[t_index].obj);
		t_index++;
		}break;
           case 'M':{ 
		int i;
		record_type=MODIF;
		if (!pass1) {
		fscanf(in_file,"%6x%2x%c%s\n",&modif.start,&modif.length,&modif.sign,modif.ref);
		if (modif.start>=text[0].start &&  modif.start<=text[0].start+text[0].length)
			i=0;
		else	i=1;
		if (modif.length%2 !=0 )
			modif.length++;
		char * c=&(text[i].obj[(modif.start-text[i].start)*2]);
		char tmp[10];
		int tmp_num,k;
		for (k=0;k<modif.length;k++)
			tmp[k]=c[k];
		tmp[k]='\0';
		tmp_num=atoi(tmp);
		FILE * tmp1=fopen("tmp1","w");
		fprintf(tmp1,"%s",tmp);
		fclose(tmp1);
		tmp1=fopen("tmp1","r");
		fscanf(tmp1,"%x",&tmp_num);
		fclose(tmp1);
		system("rm tmp1");
		if (!strcmp(modif.ref,header.name)){
				if (modif.sign=='+')
					tmp_num+=header.prog_addr;
				else
					tmp_num-=header.prog_addr;
		}
		else {for (int t=0;refer[t].name[0]!='\0';t++){
			if (!strcmp(refer[t].name,modif.ref)){
				if (modif.sign=='+')
					tmp_num+=refer[t].address;
				else
					tmp_num-=refer[t].address;
				}		
			}
		}//else
  		/*if (modif.length==5)
                        sprintf(tmp,"%05x",tmp_num);
                else if (modif.length==6)*/
                        sprintf(tmp,"%06x",tmp_num);
                for (int k=0;k<modif.length;k++)
                  if (length(tmp)>6)
                         c[k]=tmp[length(tmp)-6+k];
                  else c[k]=tmp[k];
		}}break;
	   case 'E':{
		record_type=END;
		fscanf(in_file,"%6x\n",&end.address);
		}break;
	   default:{
		while(c!='\n') c=(char)fgetc(in_file);
		read_file();
		}
	}
	return;
	
}
Input_class::Input_class(){
//	in_file=fopen("object","r");
	out_file=fopen("out_file","w");
	tmp=fopen("tmp","w");
	end_of_file=0;
	end.address=-1;
	pass1=1;
}
//--------------------------------------------
class ESTAB_class{
  public:
	struct symstr{
		char name[7];
		int address;
	};
	struct estr{
		char name[7];
		int address;
		int length;
		int sym_num;
		symstr syms[15];
	}es[10];
  	int sec_num;
  public:
	ESTAB_class();
	int found(char *);
	int found_sym(char *);
	void enter_cs(char *,int,int);
	void enter_sym(char *,int);	 
	
};

ESTAB_class::ESTAB_class(){
	for (int i=0;i<10;i++)
		es[i].syms[0].name[0]='\0';
	es[0].name[0]='\0';
	sec_num=-1;
}
int ESTAB_class::found(char * str){
	int i=0;
	while(i<=sec_num){
		if (!strcmp(es[i].name,str))
			return 1;
		else i++;
	}
	return 0;
}
int ESTAB_class::found_sym(char * str){
	int i=0;
	while (es[sec_num].syms[i].name[0]!='\0'){
		if (!strcmp(es[sec_num].syms[i].name,str))
			return 1;
		i++;
	}
	return 0;
}
void ESTAB_class::enter_cs(char * name, int address, int length){
	sec_num++;
	strcpy(es[sec_num].name,name);
	es[sec_num].address=address;
	es[sec_num].length=length;
	es[sec_num].sym_num=0;
	return;
}
void ESTAB_class::enter_sym(char * name, int address){
	strcpy(es[sec_num].syms[es[sec_num].sym_num].name,name);
	es[sec_num].syms[es[sec_num].sym_num].address=address;
	es[sec_num].sym_num++;
	return;
}
//--------------------------------------------
class control_class{
  public:
	int progaddr;
	int csaddr;
	int cslth;
	int execaddr;
  public:
	void add(){csaddr+=cslth; return;};
	void set_progaddr(){progaddr=16384; return;};
	void set_csaddr(int n){csaddr=n; return;};
	void set_cslth(int n){cslth=n; return;};
        void set_execaddr(int n){execaddr=n; return;};
};

class error{
   public:
	char err_message[100];
	int flag;
  public:
	error(){flag=0;}
	//void set_error(char []);

};

Input_class input;
ESTAB_class estab;
control_class control;
error err;
//--------------------------------------------------

void pass_1(){
	control.set_progaddr();
	control.set_csaddr(control.progaddr);
	input.read_file();
	while (!input.end_of_file){
		control.set_cslth(input.header.length);
		if (estab.found(input.header.name)){
			err.flag=1;
			printf("duplicate section name=%s.\n",input.header.name);
			return;
		}
		estab.enter_cs(input.header.name,control.csaddr,input.header.length);
		while (input.record_type!=END){
			input.read_file();
			if (input.record_type==DEFINE){
				for(int i=0;input.define[i].name[0]!='\0';i++){
					if (estab.found_sym(input.define[i].name)){
						err.flag=1;
			printf("duplicate symbol name=%s.\n",input.define[i].name);
						return;
					}
					estab.enter_sym(input.define[i].name,control.csaddr+input.define[i].address);
				}
			
			}
		}
		control.add();
		input.read_file();
	}
	input.close_open();
	return;
}
//----------------------------------------------------------------
void pass_2(){
	int son_kaldigim_yer=control.progaddr;
	control.set_csaddr(control.progaddr);
	control.set_execaddr(control.progaddr);
	input.read_file();
	while (!input.end_of_file){
		control.set_cslth(input.header.length);
		for (int i=0;i<=estab.sec_num;i++){
			if (!strcmp(input.header.name,estab.es[i].name))
				input.header.prog_addr=estab.es[i].address;  
		}
		while (input.record_type!=END){
			input.read_file();
			if (input.record_type==REFER){
				for (int i=0;i<=estab.sec_num;i++){
					for (int j=0;j<estab.es[i].sym_num;j++)
						for (int k=0;input.refer[k].name[0]!='\0';k++){
							if (!strcmp(estab.es[i].syms[j].name,input.refer[k].name))
								input.refer[k].address=estab.es[i].syms[j].address;
						}
				}
			}				
		}	
		input.text[0].start+=control.csaddr;
		input.text[1].start+=control.csaddr;
		//input.text[0].start+=son_kaldigim_yer;
		//input.text[1].start+=son_kaldigim_yer;
		//son_kaldigim_yer+=input.text[1].start+input.text[1].length;
		input.write_tmp();
		if (input.end.address!=-1){
			control.set_execaddr(control.csaddr+input.end.address);
			input.end.address=-1;
		}
		control.add();
		input.read_file();
	}	
	input.close_tmp();
	input.write_file();
	return;
}
//----------------------------------------------------------------
int main(int arg, char * args[]){
	input.in_file=fopen(args[1],"r");
	pass_1();
	pass_2();
	/*for (int i=0;i<=estab.sec_num;i++){
		printf("SECTION==>%s %4x %4x\n",estab.es[i].name,estab.es[i].address,estab.es[i].length);
		for (int j=0;j<estab.es[i].sym_num;j++)
			printf("%s %4x\n",estab.es[i].syms[j].name,estab.es[i].syms[j].address);
	}*/
	system("rm tmp");
	return 1;
}
